=== debian/changelog ===
scantailor (0.9.9-0ubuntu1) maverick; urgency=low

  * New upstream release.
  * Update debian/copyright.

 -- Alessio Treglia <quadrispro@ubuntu.com>  Mon, 28 Jun 2010 11:09:40 +0200

scantailor (0.9.8.1-0ubuntu1) maverick; urgency=low

  * New upstream release.
  * Bump Standards.
  * Switch to 3.0 (quilt) format.

 -- Alessio Treglia <quadrispro@ubuntu.com>  Wed, 12 May 2010 13:25:01 +0200

scantailor (0.9.7.2-0ubuntu1) lucid; urgency=low

  * New upstream release.
  * Update debian/copyright.

 -- Alessio Treglia <quadrispro@ubuntu.com>  Sat, 06 Feb 2010 01:48:24 +0100

scantailor (0.9.7-0ubuntu3) lucid; urgency=low

  * Try again, this time correctly specifying the desired build architectures

 -- Scott Kitterman <scott@kitterman.com>  Fri, 15 Jan 2010 00:23:08 -0500

scantailor (0.9.7-0ubuntu2) lucid; urgency=low

  * Bump boost build-depends to libboost-test1.40-dev
  * Build for Architecture: amd64 i386 ia64 powerpc sparc (not armel) due to
    arm processor limitations
    - selected processor does not support `swp r0,r3,[r2]

 -- Scott Kitterman <scott@kitterman.com>  Thu, 14 Jan 2010 21:32:03 -0500

scantailor (0.9.7-0ubuntu1) lucid; urgency=low

  * New upstream release:
    - It's now possible to manually edit picture zones that weren't
      properly auto-detected.
    - A crash that supposedly only affected the Windows version was fixed.
    - Book spine detection was improved.
    - The central area now has scrollbars.
    - Page dragging can now also be done with a middle mouse button in
      addition to the left one.
    - Experimental and optional OpenGL support to accelerate drawing
      operations.
    - Bulgarian translation was added.
  * debian/control:
    - Bump Standards.
    - Build-depend on libxrender-dev.
    - Lines should not be longer than 80 chars.

 -- Alessio Treglia <quadrispro@ubuntu.com>  Wed, 11 Nov 2009 01:30:19 +0100

scantailor (0.9.6-0ubuntu1) karmic; urgency=low

  * Initial release (LP: #370254).

 -- Артём Попов <artfwo@gmail.com>  Thu, 06 Aug 2009 17:57:26 +0700
