=== debian/control ===
Source: scantailor
Section: graphics
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Артём Попов <artfwo@gmail.com>
Build-Depends: cdbs, debhelper (>= 5), cmake (>= 2.6.0),
 libqt4-dev (>= 4.4.0), libjpeg62-dev, libpng12-dev, libtiff4-dev,
 libboost-test1.40-dev, libxrender-dev
Standards-Version: 3.8.4
Homepage: http://scantailor.sourceforge.net/

Package: scantailor
Architecture: amd64 i386 ia64 powerpc sparc
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Interactive post-processing tool for scanned pages
 Scan Tailor is an interactive post-processing tool for scanned pages. It
 performs operations such as page splitting, deskewing, adding/removing
 borders, and others. You give it raw scans, and you get pages ready to be
 printed or assembled into a PDF or DJVU file. Scanning, optical character
 recognition, and assembling multi-page documents are out of scope of this
 project.
