## scantailor 0.9.9.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -266,7 +266,7 @@
 	ADD_DEFINITIONS(-DLIBTIFF_STATIC)
 ENDIF(WIN32)
 
-INCLUDE_DIRECTORIES(. foundation interaction zones ${QT_INCLUDES})
+INCLUDE_DIRECTORIES(. foundation math interaction zones ${QT_INCLUDES})
 LINK_DIRECTORIES(${QT_LIBRARY_DIR})
 
 SET(EXTRA_LIBS)
@@ -316,6 +316,7 @@
 # crash_reporter is included unconditionally to collect translation sources from there.
 ADD_SUBDIRECTORY(crash_reporter)
 ADD_SUBDIRECTORY(foundation)
+ADD_SUBDIRECTORY(math)
 ADD_SUBDIRECTORY(imageproc)
 ADD_SUBDIRECTORY(interaction)
 ADD_SUBDIRECTORY(zones)
