=== foundation/CMakeLists.txt ===
--- 
+++ 
@@ -6,6 +6,8 @@
 	sources
 	NonCopyable.h IntrusivePtr.h RefCountable.h
 	AlignedArray.h
+	NumericTraits.h
+	FastQueue.h
 	SafeDeletingQObjectPtr.h
 	ScopedIncDec.h ScopedDecInc.h
 	Span.h VirtualFunction.h FlagOps.h
@@ -16,6 +18,7 @@
 	PropertySet.cpp PropertySet.h
 	PerformanceTimer.cpp PerformanceTimer.h
 	QtSignalForwarder.cpp QtSignalForwarder.h
+	VecNT.h
 )
 SOURCE_GROUP("Sources" FILES ${sources})
 QT4_AUTOMOC(${sources})
