=== imageproc/tests/CMakeLists.txt ===
--- 
+++ 
@@ -27,7 +27,7 @@
 
 SET(
 	libs
-	imageproc ${Boost_UNIT_TEST_FRAMEWORK_LIBRARY}
+	imageproc math foundation ${Boost_UNIT_TEST_FRAMEWORK_LIBRARY}
 	${Boost_PRG_EXECUTION_MONITOR_LIBRARY}
 	${QT_QTGUI_LIBRARY} ${QT_QTCORE_LIBRARY} ${EXTRA_LIBS}
 )
