=== debian/changelog ===
scantailor (0.9.9.2-0ubuntu2) natty; urgency=low

  * Really drop ia64 and sparc arches (change went missing in previous
    upload)

 -- Bhavani Shankar <bhavi@ubuntu.com>  Fri, 26 Nov 2010 17:32:49 +0530

scantailor (0.9.9.2-0ubuntu1) natty; urgency=low

  * New upstream release
  * Bump standards t0 3.9.1
  * Drop support for ia64 and sparc as they are no longer supported

 -- Bhavani Shankar <bhavi@ubuntu.com>  Fri, 26 Nov 2010 12:15:40 +0530

scantailor (0.9.9-0ubuntu2) natty; urgency=low

  * Bump Boost build-dep to libboost-test1.42-dev
  * Add Xrender to CMAKE_EXE_LINKER_FLAGS to fix FTBFS due to indirect linking

 -- Scott Kitterman <scott@kitterman.com>  Sat, 16 Oct 2010 15:21:41 -0400
