=== debian/control ===
--- 
+++ 
@@ -5,12 +5,12 @@
 XSBC-Original-Maintainer: Артём Попов <artfwo@gmail.com>
 Build-Depends: cdbs, debhelper (>= 5), cmake (>= 2.6.0),
  libqt4-dev (>= 4.4.0), libjpeg62-dev, libpng12-dev, libtiff4-dev,
- libboost-test1.40-dev, libxrender-dev
-Standards-Version: 3.8.4
+ libboost-test1.42-dev, libxrender-dev
+Standards-Version: 3.9.1
 Homepage: http://scantailor.sourceforge.net/
 
 Package: scantailor
-Architecture: amd64 i386 ia64 powerpc sparc
+Architecture: amd64 i386 powerpc 
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Description: Interactive post-processing tool for scanned pages
  Scan Tailor is an interactive post-processing tool for scanned pages. It
